Page MenuHomePhabricator

Run Big English fundraising on apps
Closed, ResolvedPublic

Description

We'd like to run a fundraising announcement for the Big English fundraiser.

Please place an announcment with the following properties:

Start Date: 11/30/2017 16:00:00 UTC
End Date: 12/20/2017 23:59:00 UTC

Destination URL (Android):
Destination URL (iOS):
Image URL: No image
Body copy (plaintext):
Privacy disclaimer text:
 By submitting, you are agreeing to our donor privacy policy.
Button label: Donate now
Countries included: US, CA, GB, IE, AU, NZ

Details

Related Gerrit Patches:
mediawiki/services/mobileapps : masterTweak Big English fundraiser copy and start time again
mediawiki/services/mobileapps : masterTweak Big English fundraiser copy some more
mediawiki/services/mobileapps : masterTweak Big English fundraiser copy and start time
mediawiki/services/mobileapps : masterBig English fundraiser announcements

Event Timeline

JMinor created this task.Nov 20 2017, 9:50 PM
Restricted Application added a subscriber: Aklapper. · View Herald Transcript
JMinor triaged this task as High priority.Nov 20 2017, 9:50 PM

Hi @JMinor, below are the details for the app banner. Please let me know if something is unclear or problematic in terms of feasibility! Thank you!


Start Date: 11/30/2017 16:00:00 UTC +0
End Date: 12/31/2017 23:59:00 UTC +0
Destination URL (Android): https://donate.wikimedia.org/?uselang=en&utm_medium=WikipediaAppFeed&utm_campaign=Android&utm_source=app_201712_6C_control
Destination URL (iOS): https://donate.wikimedia.org/?uselang=en&utm_medium=WikipediaAppFeed&utm_campaign=iOS&utm_source=app_201712_6C_control
Image URL: No image
Body copy (plaintext): Hi reader in %COUNTRY%, it seems you use Wikipedia a lot; I think that’s great and hope you find it useful. It’s a little awkward to ask, but today we need your help. We depend on donations averaging %CURRENCY% %AVERAGE%, but fewer than 1% of readers choose to give. If you donate just %CURRENCY% %COFFEE%, you would help keep Wikipedia thriving for years. That’s right, the price of a cup of coffee is all I ask. Please take a minute to keep Wikipedia growing. Thank you. — Jimmy Wales, Wikipedia Founder
Privacy disclaimer text: By submitting, you are agreeing to our donor privacy policy
Button label: Donate today
Countries included: US, CA, GB, IE, AU, NZ


Variables

%COUNTRY%
US: U.S.
GB: UK
AU: Australia
CA: Canada
NZ: New Zealand
IE: Ireland

%CURRENCY%
US: $
GB: £
AU: $
CA: $
NZ: $
IE: €

%AVERAGE%
US: 15
GB: 10
AU: 15
CA: 15
NZ: 15
IE: 10

%COFFEE%
US: 3
GB: 2
AU: 3
CA: 3
NZ: 3
IE: 2


Example of the final copy
Hi reader in the U.S., it seems you use Wikipedia a lot; I think that’s great and hope you find it useful. It’s a little awkward to ask, but today we need your help. We depend on donations averaging $15, but fewer than 1% of readers choose to give. If you donate just $3, you would help keep Wikipedia thriving for years. That’s right, the price of a cup of coffee is all I ask. Please take a minute to keep Wikipedia growing. Thank you. — Jimmy Wales, Wikipedia Founder


Second pair of eyes appreciated @jrobell @spatton @Pcoombe @TSkaff, thanks!

bearND claimed this task.Nov 28 2017, 6:54 PM

I assume this is only for enwiki.

@schoenbaechler we are working on implementing this, but @JMinor is out today and want to make sure he reviews the text as well.

Also @JoeWalsh will be posting a screenshot with the text in the app so we can review it as well from a UI perspective.

@JMinor @Fjalapeno here's what the sample text looks like in the app

cmadeo added a subscriber: cmadeo.Nov 28 2017, 9:50 PM

Could we add some line breaks?

Hi reader in the U.S., it seems you use Wikipedia a lot; I think that’s great and hope you find it useful.
It’s a little awkward to ask, but today we need your help. We depend on donations averaging $15, but fewer than 1% of readers choose to give. If you donate just $3, you would help keep Wikipedia thriving for years. That’s right, the price of a cup of coffee is all I ask. Please take a minute to keep Wikipedia growing.
Thank you. — Jimmy Wales, Wikipedia Founder

@JoeWalsh would it be possible to see the edits in the comment above as a screenshot? Thanks!

Thanks for the updates @Fjalapeno, @JoeWalsh & @JMinor.

+1 on @cmadeo suggestion re: line breaks (thanks for chiming in). In addition, I suggest to left align the copy, it's easier to read.

Change 394013 had a related patch set uploaded (by BearND; owner: BearND):
[mediawiki/services/mobileapps@master] Big English fundraiser announcements

https://gerrit.wikimedia.org/r/394013

@cmadeo I updated the screenshot with the line breaks. Let me know if you want to left align as per @schoenbaechler 's suggestion (and any other design tweaks).

Would it be possible to remove the first line entirely? Would help to shorten the text and remove any "we know where you're from and are monitoring how much you use the app" privacy concern.

JoeWalsh added a comment.EditedNov 29 2017, 12:08 PM

re: length, it's a full screen on a 5/5S/SE:

vs

schoenbaechler added a comment.EditedNov 29 2017, 3:17 PM

@JoeWalsh:

Thanks for the feedback. I don't recommend to leave out the first paragraph since localization has proven to be effective in our recent test history on desktop and mobile. Also, more (informative) copy helps users to make a choice.


@cmadeo:

Is it possible to use a solid background-color (e.g. #36c) for the donate button? Or are we limited to use the „ghost button“ style, which is typically used for secondary CTA’s and less effective.


@Fjalapeno, @JoeWalsh & @JMinor:
A small change request; can we update the button’s label to „Donate Now“ instead of „Donate today“ ? Thanks!


CC @MeganHernandez_WMF @jrobell @spatton @Pcoombe @TSkaff

Change 394013 merged by jenkins-bot:
[mediawiki/services/mobileapps@master] Big English fundraiser announcements

https://gerrit.wikimedia.org/r/394013

What I have so far on the server side is the text with the line breaks. The button label is still the old "Donate today". The start time is set to 11/30/2017 16:00:00 UTC. Let me know if the start time is ok. We can deploy it this afternoon if there is agreement on the content and the times.

There's currently no way for the server side to specify the text alignment or colors schemes. Those are client concerns. Keep in mind that the apps allow the users to change the (color) themes. If designers think that allowing different text alignment is useful then we can add it. Colors would probably have to be tested against all themes.

Text changes, like the donation button label, are pretty easy to do now with the currently merged code. I split the config portion into its own file, so it's easier to change things. The hardest part is probably getting agreement on it. My $0.02 on the new label is that the second word should probably be lower-case. But that's beyond my pay-grade.

@JoeWalsh Your screenshots don't show the disclaimer. If it helps I've create a paste with the current announcements: P6393.

@schoenbaechler We can update the button text, there is no facility to update the button style in the apps.

For context, this card is shown using a general announcement feature in the Android and iOS. While we can add features and customizations, such changes require updates to the apps. So we need lead time to allow things like different button styles, colors, etc… and of course design needs to see how this plays with the rest of the feed where this announcement is shown. So it will be tough to get some of your requests in at this point.

Re: text length:
I'm glad to hear the text has been tested, however I think there is a concern that the placement and interaction on the apps is wholly different than a banner on the mobile web site. It is not uncommon for mobile web and apps to have different UX which perform differently - this is actually quite common, and has led to different designs in the mobile web, android and iOS apps. All of this is to say that it would be good to also test the performance of donation text in the apps so we can verify if this text does indeed perform better in those contexts as well. Maybe this is something we can try for the next fundraiser?

Just a note deployment, if we want to get this deployed this week, we need to finalize everything today or tonight. We have 2 deployments left:

1pm PST today (Wednesday)
9am PST on Thursday

@bearND thanks for the response JSON. I think "Privacy disclaimer text: " wasn't meant to be in front of the disclaimer, but here's how everything looks for the US with the current response:

Echoing some thoughts above:
I'd prefer to not change the text styling too drastically, as this is the general style we use for feed announcements. Regarding button style, I agree that a filled button would stand out more, but we don't utilize filled buttons within the feed, so I'd worry about this card feeling too foreign if we were to change the button style.

Regarding text length:
With the full as show above text, the button will be pushed below the fold for smaller devices including the iPhone 5 (which is about 17.6% of our users reported on Piwik). As many users jump into the app to search first, not having the button above the fold could prove to be a problem for visibility.

@bearND also, could you add an extra newline (two total) between the paragraphs in the response?

Change 394107 had a related patch set uploaded (by BearND; owner: BearND):
[mediawiki/services/mobileapps@master] Tweak Big English fundraiser copy

https://gerrit.wikimedia.org/r/394107

^ Now with double the line breaks and updated button label to "Donate now".

bearND added a comment.EditedNov 29 2017, 7:26 PM

Here are the Android screenshots in light and dark theme on a Nexus 5:

I've also updated the paste (P6393).

I guess on Android the buttons are all upper case anyways, so only on iOS the lower case vs upper case in the button matters.
BTW, should there be a period at the end of the disclaimer?

RHo added a subscriber: RHo.Nov 29 2017, 7:43 PM
bearND added a comment.EditedNov 29 2017, 8:49 PM

I've added a more significant delay in there so we can deploy what we have right now (for other stuff) without accidentally triggering the announcement. Just want to be conservative for now and changed it to 12/06.

Whenever I get the go ahead we can simply adjust the start time as needed.

Change 394107 merged by Mholloway:
[mediawiki/services/mobileapps@master] Tweak Big English fundraiser copy and start time

https://gerrit.wikimedia.org/r/394107

Change 394152 had a related patch set uploaded (by BearND; owner: BearND):
[mediawiki/services/mobileapps@master] Tweak Big English fundraiser copy some more

https://gerrit.wikimedia.org/r/394152

Change 394152 merged by Mholloway:
[mediawiki/services/mobileapps@master] Tweak Big English fundraiser copy some more

https://gerrit.wikimedia.org/r/394152

The latest patch is to remove the extra "Privacy disclaimer text: ". Thanks @JoeWalsh for catching that.
I'm really glad updating the JSON payload for all the announcements is practically automated now.

Updated iOS screenshots:

@bearND:

The start time is set to 11/30/2017 16:00:00 UTC. Let me know if the start time is ok. We can deploy it this afternoon if there is agreement on the content and the times.

Start time is fine, thanks!

There's currently no way for the server side to specify the text alignment or colors schemes.

Alright, good to know!

My $0.02 on the new label is that the second word should probably be lower-case. But that's beyond my pay-grade.

Apple’s Human Interface Guidelines recommend to use title case and Google’s Material Design Guidelines recommend to use sentence case. For the sake of consistency throughout the iOS app, it’s best to let @cmadeo decide: „Donate Now“ vs „Donate now“ ?

BTW, should there be a period at the end of the disclaimer?

Yes, I’d say so! CC: @JoeWalsh @Fjalapeno


@Fjalapeno:

Thanks for the great feedback. Yes, we should definitely keep that in mind for the next one.


@JoeWalsh:

„Privacy disclaimer text:“ wasn't meant to be in front of the disclaimer

Thanks for spotting this (and the updated iOS screens; looks great!)


@cmadeo

I'd prefer to not change the text styling too drastically, as this is the general style we use for feed announcements. Regarding button style, I agree that a filled button would stand out more, but we don't utilize filled buttons within the feed, so I'd worry about this card feeling too foreign if we were to change the button style.

Thanks for the infos, makes sense to leave it as it is.


@Fjalapeno @JoeWalsh & @bearND:

Concerning the variables %COUNTRY%, %CURRENCY%, %AVERAGE% & %COFFEE%, which are country dependent: Is there a way to have a look at these as well? Or maybe post screenshots from all countries on both iOS and Android? If you say it’s fine, I’ll of course trust you! Thanks for the great work!

Other than that, I think we’re good to go!

Thanks for checking in on the button capitalization. I would prefer if we used sentence case as that is what we use throughout the app and also what is recommended in the Wikipedia manual of style: https://en.wikipedia.org/wiki/Wikipedia:Manual_of_Style/Capital_letters

Change 394205 had a related patch set uploaded (by BearND; owner: BearND):
[mediawiki/services/mobileapps@master] Tweak Big English fundraiser copy and start time again

https://gerrit.wikimedia.org/r/394205

bearND added a comment.EditedNov 29 2017, 10:41 PM

@schoenbaechler

The start time is set to 11/30/2017 16:00:00 UTC

We've already missed today's deployment window. I propose we use sometime later than that if it's important to know how long the fundraiser lasted. We can deploy tomorrow morning if that's alright. Maybe set it to 12/01/2017 00:00:00 UTC or later?

Is there a way to have a look at these as well?

The input parameters are visible in the config file. Note that I have to use a slightly different syntax for the variable substitutions, but I hope it still makes sense. If not please ping me. You probably want to also take a look at the countryVariants section starting on line 23 there.

For your convenience the output is available in the paste P6393, which I tend to update over time based on the various patches.
FYI, there are minor differences in the text between the Android and iOS variants, to adjust for different client implementations. (Android uses HTML line breaks, while iOS uses regular text line breaks (\n) since iOS treats this as plain text, not HTML. On iOS the disclaimer text is wrapped in a <p> HTML tag. Different fields have different behavior and require slightly different JSON for this to look good, unfortunately.)

schoenbaechler added a comment.EditedNov 29 2017, 11:04 PM

@bearND

We've already missed today's deployment window. (...) Maybe set it to 12/01/2017 00:00:00 UTC or later?

We were aiming for 11/30/2017 16:00:00 UTC since that’s the official mobile web banner launch time. Just to understand you correctly, is 12/01/2017 00:00:00 UTC the earliest possible time after tomorrow's deployment window? Thanks for clarifying.

The input parameters are visible in the config file.

All good, I just doubled checked it! Thanks.

bearND added a comment.EditedNov 29 2017, 11:19 PM

Well, I wanted to give it a couple of hours after the deployment is done due to caching. A client is supposed to cache this for 2 hours, but it could be that it may take longer. (I believe there was a task for iOS to try to refresh the announcements more often). We can really have it start any time you'd like. It's just that some clients wouldn't get the update in time, and you end up having some clients see it but others don't until they all have refreshed their caches.
This is more for analytics. If we don't care about analytics then it doesn't matter.

Thanks for checking! :)

bearND added a comment.EditedNov 29 2017, 11:26 PM

On second thought. To make this easy, and since we seem to agree on the text now, I could just deploy this tonight.

Change 394205 merged by Mholloway:
[mediawiki/services/mobileapps@master] Tweak Big English fundraiser copy and start time again

https://gerrit.wikimedia.org/r/394205

@bearND

On second thought. To make this easy, and since we seem to agree on the text now, I could just deploy this tonight.

If that's possible, that would be perfect, thanks!

Mentioned in SAL (#wikimedia-operations) [2017-11-30T00:56:44Z] <bsitzmann@tin> Started deploy [mobileapps/deploy@fa2a877]: Update mobileapps to dcea7d3 (T181004)

Mentioned in SAL (#wikimedia-operations) [2017-11-30T01:02:52Z] <bsitzmann@tin> Finished deploy [mobileapps/deploy@fa2a877]: Update mobileapps to dcea7d3 (T181004) (duration: 06m 08s)

It's deployed but it'll take some time for it to be visible at https://en.wikipedia.org/api/rest_v1/feed/announcements. My usual tricks to shorten this seem to be not working.

This comment was removed by Mholloway.
Mholloway added a comment.EditedNov 30 2017, 2:20 AM

The endpoint response is up, and in-app announcements will go live at 11/30/2017 16:00:00 UTC.

This comment was removed by bearND.

@bearND @Mholloway

I'm excited, thanks for the great collaboration.

Just jumping in to say Thank you to everyone involved for your help getting these ready and deployed! Look forward to seeing the banners live!

bearND updated the task description. (Show Details)Nov 30 2017, 3:52 PM
bearND updated the task description. (Show Details)
bearND added a comment.EditedNov 30 2017, 3:55 PM

Updated some of the parameters in the description to reflect the values we ended up with. Currently it is set to end the day before New Year's Eve in the UK. If we need to change that we can do that before December 13th. Afterwards is really hard since there are usually no deployments allowed during the holiday break and, of course, during the holidays most people are not working.

BTW, Now it's live live.

Thanks everyone! Can confirm that donations are coming in from this, I'll update results in this sheet every day or so.

Thanks for sharing the sheet! Very cool to see the donations coming in...

Per @jrobell we are on track to reach our goal and can set an end date for the announcement. Please update ALL announcements to end at 23:59 on December 20th.

Mholloway updated the task description. (Show Details)Dec 13 2017, 6:11 PM
Pcoombe closed this task as Resolved.Jan 4 2018, 6:54 PM

Spreadsheet updated with final numbers. Thanks everyone!

Irfi104 added a subscriber: Irfi104.Dec 6 2018, 8:51 PM

Hi @JMinor, below are the details for the app banner. Please let me know if something is unclear or problematic in terms of feasibility! Thank you!

Start Date: 11/30/2017 16:00:00 UTC +0
End Date: 12/31/2017 23:59:00 UTC +0
Destination URL (Android): https://donate.wikimedia.org/?uselang=en&utm_medium=WikipediaAppFeed&utm_campaign=Android&utm_source=app_201712_6C_control
Destination URL (iOS): https://donate.wikimedia.org/?uselang=en&utm_medium=WikipediaAppFeed&utm_campaign=iOS&utm_source=app_201712_6C_control
Image URL: No image
Body copy (plaintext): Hi reader in %COUNTRY%, it seems you use Wikipedia a lot; I think that’s great and hope you find it useful. It’s a little awkward to ask, but today we need your help. We depend on donations averaging %CURRENCY% %AVERAGE%, but fewer than 1% of readers choose to give. If you donate just %CURRENCY% %COFFEE%, you would help keep Wikipedia thriving for years. That’s right, the price of a cup of coffee is all I ask. Please take a minute to keep Wikipedia growing. Thank you. — Jimmy Wales, Wikipedia Founder
Privacy disclaimer text: By submitting, you are agreeing to our donor privacy policy
Button label: Donate today

Countries included: US, CA, GB, IE, AU, NZ

Variables
%COUNTRY%
US: U.S.
GB: UK
AU: Australia
CA: Canada
NZ: New Zealand
IE: Ireland
%CURRENCY%
US: $
GB: £
AU: $
CA: $
NZ: $
IE: €
%AVERAGE%
US: 15
GB: 10
AU: 15
CA: 15
NZ: 15
IE: 10
%COFFEE%
US: 3
GB: 2
AU: 3
CA: 3
NZ: 3

IE: 2

Example of the final copy

Hi reader in the U.S., it seems you use Wikipedia a lot; I think that’s great and hope you find it useful. It’s a little awkward to ask, but today we need your help. We depend on donations averaging $15, but fewer than 1% of readers choose to give. If you donate just $3, you would help keep Wikipedia thriving for years. That’s right, the price of a cup of coffee is all I ask. Please take a minute to keep Wikipedia growing. Thank you. — Jimmy Wales, Wikipedia Founder

Second pair of eyes appreciated @jrobell @spatton @Pcoombe @TSkaff, thanks!

Hi @JMinor, below are the details for the app banner. Please let me know if something is unclear or problematic in terms of feasibility! Thank you!

Start Date: 11/30/2017 16:00:00 UTC +0
End Date: 12/31/2017 23:59:00 UTC +0
Destination URL (Android): https://donate.wikimedia.org/?uselang=en&utm_medium=WikipediaAppFeed&utm_campaign=Android&utm_source=app_201712_6C_control
Destination URL (iOS): https://donate.wikimedia.org/?uselang=en&utm_medium=WikipediaAppFeed&utm_campaign=iOS&utm_source=app_201712_6C_control
Image URL: No image
Body copy (plaintext): Hi reader in %COUNTRY%, it seems you use Wikipedia a lot; I think that’s great and hope you find it useful. It’s a little awkward to ask, but today we need your help. We depend on donations averaging %CURRENCY% %AVERAGE%, but fewer than 1% of readers choose to give. If you donate just %CURRENCY% %COFFEE%, you would help keep Wikipedia thriving for years. That’s right, the price of a cup of coffee is all I ask. Please take a minute to keep Wikipedia growing. Thank you. — Jimmy Wales, Wikipedia Founder
Privacy disclaimer text: By submitting, you are agreeing to our donor privacy policy
Button label: Donate today

Countries included: US, CA, GB, IE, AU, NZ

Variables
%COUNTRY%
US: U.S.
GB: UK
AU: Australia
CA: Canada
NZ: New Zealand
IE: Ireland
%CURRENCY%
US: $
GB: £
AU: $
CA: $
NZ: $
IE: €
%AVERAGE%
US: 15
GB: 10
AU: 15
CA: 15
NZ: 15
IE: 10
%COFFEE%
US: 3
GB: 2
AU: 3
CA: 3
NZ: 3

IE: 2

Example of the final copy

Hi reader in the U.S., it seems you use Wikipedia a lot; I think that’s great and hope you find it useful. It’s a little awkward to ask, but today we need your help. We depend on donations averaging $15, but fewer than 1% of readers choose to give. If you donate just $3, you would help keep Wikipedia thriving for years. That’s right, the price of a cup of coffee is all I ask. Please take a minute to keep Wikipedia growing. Thank you. — Jimmy Wales, Wikipedia Founder

Second pair of eyes appreciated @jrobell @spatton @Pcoombe @TSkaff, thanks!

Hi @JMinor, below are the details for the app banner. Please let me know if something is unclear or problematic in terms of feasibility! Thank you!

Start Date: 11/30/2017 16:00:00 UTC +0
End Date: 12/31/2017 23:59:00 UTC +0
Destination URL (Android): https://donate.wikimedia.org/?uselang=en&utm_medium=WikipediaAppFeed&utm_campaign=Android&utm_source=app_201712_6C_control
Destination URL (iOS): https://donate.wikimedia.org/?uselang=en&utm_medium=WikipediaAppFeed&utm_campaign=iOS&utm_source=app_201712_6C_control
Image URL: No image
Body copy (plaintext): Hi reader in %COUNTRY%, it seems you use Wikipedia a lot; I think that’s great and hope you find it useful. It’s a little awkward to ask, but today we need your help. We depend on donations averaging %CURRENCY% %AVERAGE%, but fewer than 1% of readers choose to give. If you donate just %CURRENCY% %COFFEE%, you would help keep Wikipedia thriving for years. That’s right, the price of a cup of coffee is all I ask. Please take a minute to keep Wikipedia growing. Thank you. — Jimmy Wales, Wikipedia Founder
Privacy disclaimer text: By submitting, you are agreeing to our donor privacy policy
Button label: Donate today

Countries included: US, CA, GB, IE, AU, NZ

Variables
%COUNTRY%
US: U.S.
GB: UK
AU: Australia
CA: Canada
NZ: New Zealand
IE: Ireland
%CURRENCY%
US: $
GB: £
AU: $
CA: $
NZ: $
IE: €
%AVERAGE%
US: 15
GB: 10
AU: 15
CA: 15
NZ: 15
IE: 10
%COFFEE%
US: 3
GB: 2
AU: 3
CA: 3
NZ: 3

IE: 2

Example of the final copy

Hi reader in the U.S., it seems you use Wikipedia a lot; I think that’s great and hope you find it useful. It’s a little awkward to ask, but today we need your help. We depend on donations averaging $15, but fewer than 1% of readers choose to give. If you donate just $3, you would help keep Wikipedia thriving for years. That’s right, the price of a cup of coffee is all I ask. Please take a minute to keep Wikipedia growing. Thank you. — Jimmy Wales, Wikipedia Founder

Second pair of eyes appreciated @jrobell @spatton @Pcoombe @TSkaff, thanks!

Thanks for checking in on the button capitalization. I would prefer if we used sentence case as that is what we use throughout the app and also what is recommended in the Wikipedia manual of style: https://en.wikipedia.org/wiki/Wikipedia:Manual_of_Style/Capital_letters .